<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 17/09/14
 * Time: 10:53
 */

namespace Geral\Logic\FonteDados;

use Geral\Entities\Linhafontedados;
use Setforms2\Runtime\Connection;
use Setforms2\Shared\Registry;

class Linha {
    public static function insertLinhaFonteDados($params)
    {
        $db = Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = Registry::getEntityManager();

        try {
            $linha = new Linhafontedados();
            $linha->setNrlinhafontedados($params['NRLINHAFONTEDADOS']);
            $linha->setNrfontedados($params['NRFONTEDADOS']);
            $linha->setDslinhafontedados($params['DSLINHAFONTEDADOS']);
            $linha->setTxcomandosql($params['TXCOMANDOSQL']);
            $linha->setIdposicaolinha($params['IDPOSICAOLINHA']);
            $linha->setNrintervaloinicial($params['NRINTERVALOINICIAL']);
            $linha->setNrintervalofinal($params['NRINTERVALOFINAL']);
            $linha->setVridlinhaporcoluna($params['VRIDLINHAPORCOLUNA']);
            $linha->setNrorg($params['NRORG']);
            $linha->setNrorginclusao($params['NRORG']);
            $linha->setNrorgultatu($params['NRORG']);
            $linha->setDtinclusao($params['DATA_ATUAL']);
            $linha->setDtultatu($params['DATA_ATUAL']);
            $linha->setCdoperinclusao($params['CDOPERADOR']);
            $linha->setCdoperultatu($params['CDOPERADOR']);

            $linha->persist();

            $connection->flush();
            $db->getConn()->commit();
        } catch(\Exception $e) {
            $db->getConn()->rollback();
            throw $e;
        }
    }

    public static function getColunasComandoSQL($sql, $params)
    {
        try{
            $config = \Setforms2\Shared\Config::getInstance();

            $user        = $config->getConnectionUsername();
            $password    = \Setforms2\Shared\Util\Util::decrypt($config->getConnectionPassword());
            $host        = $config->getConnectionHost();
            $serviceName = $config->getConnectionServicename();

            $conn = oci_connect($user, $password, $host.'/'.$serviceName);

            if (!$conn) {
                $errorConnect = oci_error();
                return $errorConnect['message'];
            }

            $stid = oci_parse($conn, $sql);

            if (!$stid) {
                $errorParse = oci_error($conn);
                return $errorParse['message'];
            }

            $valueParam = null;
            foreach($params as $param) {
                oci_bind_by_name($stid, $param, $valueParam);
            }

            $execute = oci_execute($stid);

            if (!$execute) {
                $errorExecute = oci_error($stid);
                $message = 'Ocorreu um erro ao executar: "'.$errorExecute['sqltext'].'". '.$errorExecute['message'];
                return $message;
            }

            $nrColums = oci_num_fields($stid);

            for ($i = 1; $i <= $nrColums; ++$i) {
                $nmColums[] = oci_field_name($stid, $i);
            }

            oci_free_statement($stid);
            oci_close($conn);

            return $nmColums;
        } catch(\Exception $e) {
            throw $e;
        }
    }
} 