package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.LoginPMEFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.ElaboracaoCardapioPMEPage;
import com.javaseleniumtemplate.pages.GeracaodeProdutoAcabadoPage;
import com.javaseleniumtemplate.pages.LoginPMEPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ElaboracaoCardapioPMETest extends TestBase {
    MainPage mainPage;
    MainFlows mainFlows;
    ElaboracaoCardapioPMEPage elaboracaocardapiopmepage;
    LoginPMEFlows loginpmeflows;

    // CRIANDO UM CARDÁPIO
    @Test
    public void elaboracaocardapiopme() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";
        String datainicio = "30112022";
        String datafim = "30112022";
        String descricaocarp = "Cardápio Almoço infantil nov.";
        String msgesperada = "Cardápio";

        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.Preenchercamposfiltro(datainicio, datafim, descricaocarp);

        String statusatual = elaboracaocardapiopmepage.RetornaMsgCardapioCriado();

        Assert.assertEquals(statusatual, msgesperada);

        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    // TESTE 02 - SELECIONANDO CARDÁPIO JÁ CRIADO
    @Test
    public void SelecionaCardapioCriado() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";
        String comensais = "15";
        String msgesperada = "STROGONOV DE FRUTOS DO MAR";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.AlterarComensais();
        elaboracaocardapiopmepage.AdicionarPrato(comensais);

        String statusatual2 = elaboracaocardapiopmepage.VerificarsePratoFoiAdicionado();

        Assert.assertEquals(statusatual2, msgesperada);

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    // TESTE 03 - EXCLUIR PERÍODO
    @Test
    public void ExclusaodoPeriodo() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";
        String msgesperada = "Excluído com sucesso!";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.ExcluirPratopeloPeriodo();

        String statusatual3 = elaboracaocardapiopmepage.ConfirmacaodeExclusao();

        Assert.assertEquals(statusatual3, msgesperada);

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    // TESTE 04 - OPÇÃO DE SELECIONAR O TIPO DE CARDÁPIO NÃO ESTÁ FUNCIONANDO - ERRO PROVAVEL NO HTML / GUSTAVO TENTOU ME AJUDAR E AINDA NÃO CONSEGUIU
    @Test
    public void ImportarCardapioDia() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";
        String comens = "2";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.ImportarCardpDia(comens);

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    // TESTE 05 - ALTERANDO CONFIGURACOESS NO CARDAPIO - OPÇÃO DE SELECIONAR TIPO DE CARDÁPIO IGUAL ANTERIOR
    @Test
    public void ConfiguracoesCardapio() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";
        String DataIncluirCard = "07/12/2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.AdicionarPratoConfigCardapio();
        elaboracaocardapiopmepage.ExcluirPratoConfigCardapio();
        elaboracaocardapiopmepage.AbaImportacaoPorTipodeCardapio(DataIncluirCard);

        try {
            Thread.sleep(4000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    // TESTE 06 - EMISSÃO DOS RELATÓRIOS - CARDÁPIO DO DIA
    @Test
    public void EmitirRelatoriosDia() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.EmissaoCardapioDia();

        try {
            Thread.sleep(4000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    // TESTE 07 - EMISSÃO DOS RELATÓRIOS - CARDÁPIO DA SEMANA
    @Test
    public void EmitirRelatoriosSemana() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.EmissaoCardapioSemana();

        try {
            Thread.sleep(4000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    // TESTE 08 - EMISSÃO DOS RELATÓRIOS - EMISSÃO DO CARDÁPIO DO PERIODO
    @Test
    public void EmitirRelatoriosPeriodo() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.EmissaoCardapioPeriodo();

        try {
            Thread.sleep(4000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    // TESTE 09 - ATUALIZAR COMENSAIS
    @Test
    public void AtualizarComensais() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.AtualizarComensais();

        try {
            Thread.sleep(4000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    // TESTE 10 - ACOMPANHAMENTO DE CUSTO
    @Test
    public void AcompanhamentoCusto() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";

        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.AcompanhamentodeCustos();

    }

    // TESTE 11 - ANALISE DE CUSTO
    @Test
    public void AnalisedeCusto() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";

        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.AnaliseDeCusto();
    }

    // TESTE 12 - RANKING DE PRATOS
    @Test
    public void RankingdePratos(){
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";

        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.RankingdePratos();
    }

    // TESTE 13 - ANALISE NUTRICIONAL
    @Test
    public void AnaliseNutricional(){
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";

        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.AcessarAnaliseNutricional();
    }

    // TESTE 14 - COPIA PRATO E COMENSAIS
    @Test
    public void CopiaPratoeComensais(){
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.CopiarPratoeComensais();
    }

    //TESTE 15 - CARDAPIO ESPECIFICO PARA UNIDADE AGREGADA
    @Test
    public void CardapioEspecifico(){
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.CardapioAgregada();

    }

    //TESTE 16 - ANALISE DE CORES
    @Test
    public void AnalisedeCores(){
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        elaboracaocardapiopmepage = new ElaboracaoCardapioPMEPage();


        String usuario = "francielly.teste";
        String senha = "Teknisa2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        elaboracaocardapiopmepage.AcessarTela();
        elaboracaocardapiopmepage.SelecionarCardapioJaCriado();
        elaboracaocardapiopmepage.AnalisedeCores();
    }
}